unit NarodBot_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SHDocVw, ExtCtrls, ComObj, ComCtrls, IniFiles, Spin,
  ShellAPI, CheckLst;

const
  WM_TASKBARICONNOTIFY = WM_USER + 289;

type
  TFormNarodBot = class(TForm)
    TimerRestart: TTimer;
    TimerGo: TTimer;
    PageControl: TPageControl;
    TabSheetOptions: TTabSheet;
    TabSheetChat: TTabSheet;
    TabSheetBrowser: TTabSheet;
    WebBrowser: TWebBrowser;
    EditLink: TEdit;
    ButtonGo: TButton;
    CheckBoxAuto: TCheckBox;
    ButtonStop: TButton;
    ButtonInfo: TButton;
    CheckBoxNickChange: TCheckBox;
    EditNick: TEdit;
    Label3: TLabel;
    EditPassword: TEdit;
    EditLogin: TEdit;
    CheckBoxAuth: TCheckBox;
    Label2: TLabel;
    EditChatLink: TEdit;
    Label4: TLabel;
    EditLogFile: TEdit;
    CheckBoxLogIncludeDate: TCheckBox;
    Label5: TLabel;
    SpinEditFloodCount: TSpinEdit;
    Label6: TLabel;
    SpinEditFloodSize: TSpinEdit;
    CheckBoxFloodDebug: TCheckBox;
    CheckBoxPopupOnMessage: TCheckBox;
    CheckBoxPopupOnNick: TCheckBox;
    CheckBoxOnNick: TCheckBox;
    EditOnNick: TEdit;
    PanelD: TPanel;
    PanelR: TPanel;
    CheckListBoxNicks: TCheckListBox;
    PanelRU: TPanel;
    PanelRD: TPanel;
    ButtonIgnore: TButton;
    SplitterLR: TSplitter;
    PanelL: TPanel;
    ComboBoxFilter: TComboBox;
    RichEditChat: TRichEdit;
    EditMsg: TEdit;
    ButtonFilter: TButton;
    procedure ButtonGoClick(Sender: TObject);
    procedure WebBrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonInfoClick(Sender: TObject);
    procedure TimerRestartTimer(Sender: TObject);
    procedure TimerGoTimer(Sender: TObject);
    procedure CheckBoxFloodDebugClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure EditMsgKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonIgnoreClick(Sender: TObject);
    procedure CheckListBoxNicksDblClick(Sender: TObject);
    procedure ButtonFilterClick(Sender: TObject);
  private
    { Private declarations }
    procedure WMTaskBarIconNotify(var Message: TMessage);
      message WM_TASKBARICONNOTIFY;
    procedure ApplicationMinimize(Sender: TObject);
  public
    { Public declarations }
    FPrevLog: TStringList;
    FNick: string;
    FIsFirst: Boolean;
    FMsgTicks: DWORD;
  end;

var
  FormNarodBot: TFormNarodBot;

implementation

{$R *.DFM}

const
  ExpireMsgTicks = 3 * 60000;
  MaxMsgLength = 167;
  ChatMessagesFrame = 'Chat_Messages';
  LoginForm = 'LoginForm';
  LoginItem = 'login';
  PasswordItem = 'passwd';
  EditUserForm = 'edituser';
  ChatEnterForm = 'enter_form';
  ChatUserNameItem = 'CF_UserName';
  ChatSubmitButton = 'Submit';
  SearchForm = 'search';
  ChatUserListFrame = 'Chat_UserList';
  ChatUserListForm = 'userlist';
  ChatUserItem = 'DelList[]';
  ChatDelUserButton = 'deluser';
  ChatForm = 'ChatForm';
  ChatMessageItem = 'Message';
  IgnoreNickMark = ' (x) ';

const
  IsIconAdded: Boolean = False;
  MainIconStr = 'MAINICON';
  TaskBarIconID = 135;

function WindowsToDos(const S: string): string;
begin
  SetLength(Result, Length(S));
  if Length(Result) > 0 then
  begin
    FillChar(Result[1], Length(Result), 0);
    CharToOemBuff(@S[1], @Result[1], Length(Result));
  end;
end;

function AddTaskBarIcon(IconHint: string; Wnd: hWnd): Boolean;
  var
    i: Integer;
    nd: TNotifyIconData;
begin
  Result := False;
  if IsIconAdded then
    Exit;
  nd.cbSize := SizeOf(nd);
  nd.Wnd := Wnd;
  nd.uID := TaskBarIconID;
  nd.uFlags := nif_Message or nif_Icon or nif_Tip;
  nd.uCallbackMessage := WM_TASKBARICONNOTIFY;
  nd.hIcon := LoadIcon(hInstance, MainIconStr);
  FillChar(nd.szTip, SizeOf(nd.szTip), #0);
  i := Length(IconHint);
  if i > SizeOf(nd.szTip) - 1 then
    i := SizeOf(nd.szTip) - 1;
  Move(IconHint[1], nd.szTip, i);
  Result := Shell_NotifyIcon(Nim_Add, @nd);
  if not Result then
    Result := Shell_NotifyIcon(Nim_Modify, @nd);
  if Result then
    IsIconAdded := True;
end;

function DelTaskBarIcon(Wnd: hWnd): Boolean;
  var
    nd: TNotifyIconData;
begin
  Result := False;
  if not IsIconAdded then Exit;
  nd.cbSize := SizeOf(nd);
  nd.Wnd := Wnd;
  nd.uID := TaskBarIconID;
  nd.uFlags := 0;
  Result := Shell_NotifyIcon(Nim_Delete, @nd);
  if Result then
    IsIconAdded := False;
end;

procedure TFormNarodBot.WMTaskBarIconNotify(var Message: TMessage);
begin
  if (Message.LParam <> wm_RButtonDown) and
  (Message.LParam <> wm_LButtonDown) then
    Exit;
  Show;
  Application.Restore;
  Application.BringToFront;
end;

procedure TFormNarodBot.ApplicationMinimize(Sender: TObject);
begin
  Hide;
end;

procedure TFormNarodBot.ButtonGoClick(Sender: TObject);
begin
  TimerRestart.Enabled := True;
  if EditLink.Text <> '' then
  begin
    FIsFirst := True;
    WebBrowser.Navigate(EditLink.Text);
  end;
end;

procedure TFormNarodBot.WebBrowserDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
  const
    FilterAll = 0;
    FilterPrivate = 1;
    FilterFrom = 2;
    FilterPrivateFrom = 3;
  var
    is_found, nick_found, is_ok: Boolean;
    i, j, cnt, n_pos: Integer;
    s, s_nick: string;
    log, nicks, leaving_users: TStringList;
    t: TextFile;
    doc, v: OleVariant;
  {}
  function ReadNicks(var Doc, V: OleVariant): string;
    var
      i: Integer;
  begin
    Result := '';
    for i := 0 to Doc.parentWindow.frames.length - 1 do
    begin
      V := Doc.parentWindow.frames.item(i);
      if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
        if V.name = ChatUserListFrame then
        begin
          V := V.document;
          if (not VarIsEmpty(V)) and (not VarIsNull(V)) then
            if (not VarIsEmpty(V.body)) and (not VarIsNull(V.body)) then
            begin
              Result := V.body.innerText;
              Break;
            end;
        end;
    end;
  end;
  {}
  function MarkFlooder(var Doc: OleVariant;
  const FlooderNick: string; DoKick: Boolean): Boolean;
    var
      i, j, n, idx: Integer;
      s: string;
      users: TStringList;
      v: OleVariant;
  begin
    Result := False;
    {     }
    v := Unassigned;
    s := ReadNicks(Doc, v);
    if Trim(s) = '' then
      Exit;
    {  }
    idx := -1;
    if FlooderNick <> '' then
    begin
      users := TStringList.Create;
      try
        users.Text := s;
        n := -1;
        for i := 0 to users.Count - 1 do
        begin
          if (Trim(users[i]) <> '') or (n > 0) then
            n := n + 1;
          if users[i] = FlooderNick then
          begin
            idx := n;
            Break;
          end;
        end;
      finally
        users.Free;
      end;
      if idx = -1 then
        Exit;
    end;
    { }
    if (FlooderNick <> '') or (DoKick) then
      for i := 0 to v.forms.length - 1 do
      begin
        v := v.forms.item(i);
        if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
          if v.name = ChatUserListForm then
          begin
            if FlooderNick <> '' then
              for j := 0 to v.elements.length - 1 do
              begin
                if v.elements.item(j).name = ChatUserItem then
                  if idx <= 0 then
                  begin
                    v.elements.item(j).checked := True;
                    Result := True;
                    Break;
                  end
                  else
                    idx := idx - 1;
              end;
            { }
            if DoKick then
              for j := 0 to v.elements.length - 1 do
                if v.elements.item(j).name = ChatDelUserButton then
                  v.elements.item(j).click;
            Break;
          end;
      end;
  end;
  {}
  procedure UpdateNicks(var Doc: OleVariant; var T: TextFile;
  LeavingUsers: TStringList);
    const
      CheckedNickFlag = $1;
      IgnoredNickFlag = $2;
    var
      is_found, is_exists: Boolean;
      i, j: Integer;
      s: string;
      found_users: TList;
      users: TStringList;
      v: OleVariant;
  begin
    v := Unassigned;
    { }
    s := ReadNicks(Doc, v);
    found_users := nil;
    users := TStringList.Create;
    try
      users.Text := s;
      found_users := TList.Create;
      found_users.Count := CheckListBoxNicks.Items.Count;
      i := 0;
      while i < users.Count do
        if Trim(users[i]) = '' then
          users.Delete(i)
        else
        begin
          is_exists := False;
          for j := 0 to CheckListBoxNicks.Items.Count - 1 do
          begin
            is_found := False;
            s := CheckListBoxNicks.Items[j];
            if Length(s) >= Length(IgnoreNickMark) then
              if Copy(s, 1, Length(IgnoreNickMark)) = IgnoreNickMark then
              begin
                is_found := True;
                s := Copy(s, Length(IgnoreNickMark) + 1,
                  Length(s) - Length(IgnoreNickMark));
              end;
            if s = users[i] then
            begin
              if CheckListBoxNicks.Checked[j] then
                users.Objects[i] :=
                  Pointer(Integer(users.Objects[i]) or CheckedNickFlag);
              if is_found then
                users.Objects[i] :=
                  Pointer(Integer(users.Objects[i]) or IgnoredNickFlag);
              is_exists := True;
              found_users[j] := Pointer(Ord(True));
              Break;
            end;
          end;
          if (not FIsFirst) and (ComboBoxFilter.ItemIndex = FilterAll) and
          (not is_exists) then
          begin
            s := '*** ' + FormatDateTime('hh:nn:ss', Now) +
              ' ' + users[i] + ' ';
            RichEditChat.Lines.Add(s);
            SendMessage(RichEditChat.Handle, EM_SCROLLCARET, $7FFFFFFF, 0);
            WriteLn(T, s);
          end;
          i := i + 1;
        end;
      if (not FIsFirst) and (ComboBoxFilter.ItemIndex = FilterAll) then
        for i := 0 to CheckListBoxNicks.Items.Count - 1 do
          if found_users[i] <> Pointer(Ord(True)) then
            LeavingUsers.Add('*** ' + FormatDateTime('hh:nn:ss', Now) +
              ' ' + CheckListBoxNicks.Items[i] + ' ');
      {  }
      j := CheckListBoxNicks.Items.Count;
      if users.Count < j then
        j := users.Count;
      for i := 0 to j - 1 do
      begin
        if Integer(users.Objects[i]) and IgnoredNickFlag = IgnoredNickFlag then
          s := IgnoreNickMark + users[i]
        else
          s := users[i];
        if s <> CheckListBoxNicks.Items[i] then
          CheckListBoxNicks.Items[i] := s;
        is_found := (Integer(users.Objects[i]) and CheckedNickFlag =
          CheckedNickFlag);
        if is_found <> CheckListBoxNicks.Checked[i] then
          CheckListBoxNicks.Checked[i] := is_found;
      end;
      while CheckListBoxNicks.Items.Count > users.Count do
        CheckListBoxNicks.Items.Delete(CheckListBoxNicks.Items.Count - 1);
      for i := CheckListBoxNicks.Items.Count to users.Count - 1 do
      begin
        if Integer(users.Objects[i]) and IgnoredNickFlag = IgnoredNickFlag then
          CheckListBoxNicks.Items.Add(IgnoreNickMark + users[i])
        else
          CheckListBoxNicks.Items.Add(users[i]);
        CheckListBoxNicks.Checked[CheckListBoxNicks.Items.Count - 1] :=
          (Integer(users.Objects[i]) and CheckedNickFlag = CheckedNickFlag);
      end;
    finally
      try
        users.Free;
      finally
        if Assigned(found_users) then
          found_users.Free;
      end;
    end;
  end;
  {}
begin
  doc := WebBrowser.Document;
  if (VarIsEmpty(doc)) or (VarIsNull(doc)) then
    Exit;
  {}
  {,   }
  try
    is_found := False;
    for i := 0 to doc.forms.length - 1 do
    begin
      v := doc.forms.item(i);
      if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
      begin
        if v.name = LoginForm then
          is_found := True;
        if (v.name = LoginForm) and (CheckBoxAuth.Checked) and
        (EditLogin.Text <> '') and (EditPassword.Text <> '') then
        begin
          for j := 0 to v.elements.length - 1 do
          begin
            if v.elements.item(j).name = LoginItem then
              v.elements.item(j).value := EditLogin.Text;
            if v.elements.item(j).name = PasswordItem then
              v.elements.item(j).value := EditPassword.Text;
          end;
          v.submit;
        end;
        if (v.name = EditUserForm) and (EditChatLink.Text <> '') then
        begin
          TimerGo.Enabled := True;
          Exit;
        end;
        if v.name = ChatEnterForm then
        begin
          for j := 0 to v.elements.length - 1 do
            if v.elements.item(j).name = ChatUserNameItem then
            begin
              s := '';
              if (CheckBoxNickChange.Checked) and (EditNick.Text <> '') then
              begin
                s := IntToStr(Random(100000));
                while Length(s) < 5 do
                  s := '0' + s;
              end;
              if EditNick.Text <> '' then
              begin
                v.elements.item(j).value := EditNick.Text + s;
                FNick := EditNick.Text + s;
              end
              else
                FNick := v.elements.item(j).value;
              FIsFirst := True;
            end;
          if (EditNick.Text <> '') and (EditChatLink.Text <> '') then
            for j := 0 to v.elements.length - 1 do
              if v.elements.item(j).name = ChatSubmitButton then
                v.elements.item(j).click;
        end;
      end;
    end;
    if not is_found then
      for i := 0 to doc.forms.length - 1 do
      begin
        v := doc.forms.item(i);
        if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
          if (v.name = SearchForm) and (EditChatLink.Text <> '') then
          begin
            TimerGo.Enabled := True;
            Exit;
          end;
      end;
  except
    on EOleException do;
  end;
  {}
  { }
  try
    s := '';
    for i := 0 to doc.parentWindow.frames.length - 1 do
    begin
      v := doc.parentWindow.frames.item(i);
      if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
        if v.name = ChatMessagesFrame then
        begin
          v := v.document;
          if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
          begin
            v := v.body;
            if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
            begin
              s := v.innerText;
              TimerRestart.Enabled := False;
              TimerRestart.Enabled := True;
              Break;
            end;
          end;
        end;
    end;
    if Trim(s) = '' then
      Exit;
  except
    on EOleException do
      Exit;
  end;
  { }
  n_pos := -1;
  log := TStringList.Create;
  try
    log.Text := s;
    if Assigned(FPrevLog) then
    begin
      cnt := log.Count;
      if FPrevLog.Count < cnt then
        cnt := FPrevLog.Count;
      for i := cnt - 1 downto 0 do
      begin
        n_pos := i;
        for j := i downto 0 do
          if log[j] <> FPrevLog[j + (cnt - 1 - i)] then
          begin
            n_pos := -1;
            Break;
          end;
        if n_pos <> -1 then
          Break;
      end;
    end;
  except
    log.Free;
  end;
   try
    if Assigned(FPrevLog) then
      FPrevLog.Free;
  finally
    FPrevLog := log;
  end;
  { }
  is_found := False;
  nick_found := False;
  if n_pos + 1 <= log.Count - 1 then
  begin
    s := ExtractFilePath(EditLogFile.Text);
    if Length(s) < 2 then
      s := ExtractFilePath(ParamStr(0))
    else if (s[1] <> '\') and (s[1] <> '/') and (s[2] <> ':') then
      s := ExtractFilePath(ParamStr(0));
    s := s + ChangeFileExt(ExtractFileName(EditLogFile.Text), '');
    if CheckBoxLogIncludeDate.Checked then
      s := s + '.' + FormatDateTime('yyyymmdd', Now);
    s := s + ExtractFileExt(EditLogFile.Text);
    AssignFile(t, s);
    if FileExists(s) then
      Append(t)
    else
      Rewrite(t);
    try
      leaving_users := nil;
      nicks := nil;
      if (not FIsFirst) and ((SpinEditFloodCount.Value > 0) or
      (SpinEditFloodSize.Value > 0) or (CheckBoxFloodDebug.Checked)) then
      begin
        nicks := TStringList.Create;
        nicks.Sorted := True;
      end;
      try
        leaving_users := TStringList.Create;
        UpdateNicks(doc, t, leaving_users);
        for i := n_pos + 1 to log.Count - 1 do
        begin
          {}
          s := TrimLeft(log[i]);
          j := Pos(' ', s);
          if j > 0 then
            s := Copy(s, j + 1, Length(s) - j);
          s_nick := '';
          j := Pos(': ', s);
          if j > 0 then
          begin
            s_nick := Copy(s, 1, j - 1);
            s := Copy(s, j + 2, Length(s) - j - 1);
          end;
          if (not FIsFirst) and ((((CheckBoxPopupOnMessage.Checked) or
          (CheckBoxPopupOnNick.Checked)) and (not is_found)) or
          ((CheckBoxOnNick.Checked) and (EditOnNick.Text <> '') and
          (not nick_found))) or (Assigned(nicks)) then
          begin
            if (not FIsFirst) and (CheckBoxPopupOnMessage.Checked) and
            (not is_found) then
              if (s_nick <> '') and (s_nick <> FNick) then
                is_found := True;
            if (not FIsFirst) and (((CheckBoxPopupOnNick.Checked) and
            (not is_found)) or ((CheckBoxOnNick.Checked) and
            (EditOnNick.Text <> '') and (not nick_found))) then
              if (s_nick <> '') and (s_nick <> FNick) then
                if Pos(FNick, s) > 0 then
                begin
                  if (CheckBoxPopupOnNick.Checked) and (not is_found) then
                    is_found := True;
                  if (CheckBoxOnNick.Checked) and (EditOnNick.Text <> '') and
                  (not nick_found) then
                    if GetTickCount - FMsgTicks >= ExpireMsgTicks then
                    begin
                      nick_found := True;
                      FMsgTicks := GetTickCount;
                    end;
                end;
          end;
          { }
          if Assigned(nicks) then
            if (s_nick <> '') and (s_nick <> FNick) then
            begin
              if not nicks.Find(s_nick, cnt) then
              begin
                cnt := nicks.Add(s_nick);
                nicks.Objects[cnt] := TStringList.Create;
              end;
              (nicks.Objects[cnt] as TStringList).Add(s);
            end;
          {    }
          is_ok := (FNick = s_nick);
          if ComboBoxFilter.ItemIndex = FilterAll then
            is_ok := True
          else if (ComboBoxFilter.ItemIndex = FilterPrivate) or
          (ComboBoxFilter.ItemIndex = FilterPrivateFrom) then
            is_ok := (Pos(AnsiUpperCase(FNick), AnsiUpperCase(s)) > 0);
          if (not is_ok) and ((ComboBoxFilter.ItemIndex = FilterFrom) or
          (ComboBoxFilter.ItemIndex = FilterPrivateFrom)) then
            for j := 0 to CheckListBoxNicks.Items.Count - 1 do
              if CheckListBoxNicks.Checked[j] then
                if CheckListBoxNicks.Items[j] = s_nick then
                begin
                  is_ok := True;
                  Break;
                end;
          if is_ok then
            for j := 0 to CheckListBoxNicks.Items.Count - 1 do
              if Length(CheckListBoxNicks.Items[j]) >=
              Length(IgnoreNickMark) then
                if CheckListBoxNicks.Items[j] = IgnoreNickMark + s_nick then
                begin
                  is_ok := False;
                  Break;
                end;
          if is_ok then
          begin
            RichEditChat.Lines.Add(log[i]);
            SendMessage(RichEditChat.Handle, EM_SCROLLCARET, $7FFFFFFF, 0);
            WriteLn(t, log[i]);
          end;
        end;
        for i := 0 to leaving_users.Count - 1 do
        begin
          RichEditChat.Lines.Add(leaving_users[i]);
          SendMessage(RichEditChat.Handle, EM_SCROLLCARET, $7FFFFFFF, 0);
          WriteLn(t, leaving_users[i]);
        end;
        {  }
        if Assigned(nicks) then
        begin
          j := 0;
          for i := 0 to nicks.Count - 1 do
          begin
            if CheckBoxFloodDebug.Checked then
            begin
              AllocConsole;
              if i = 0 then
                WriteLn;
              WriteLn(WindowsToDos(nicks[i] + ': ' +
                IntToStr((nicks.Objects[i] as TStringList).Count) + ' - ' +
                IntToStr(Length((nicks.Objects[i] as TStringList).Text))));
            end;
            if ((SpinEditFloodCount.Value > 0) and
            ((nicks.Objects[i] as TStringList).Count >=
            SpinEditFloodCount.Value)) or
            ((SpinEditFloodSize.Value > 0) and
            (Length((nicks.Objects[i] as TStringList).Text) >=
            SpinEditFloodSize.Value)) then
              if MarkFlooder(doc, nicks[i], False) then
                j := j + 1;
          end;
          if j > 0 then
            MarkFlooder(doc, '', True);
        end;
      finally
        try
          if Assigned(nicks) then
            try
              for i := nicks.Count - 1 downto 0 do
                if Assigned(nicks.Objects[i]) then
                  nicks.Objects[i].Free;
            finally
              nicks.Free;
            end;
        finally
          if Assigned(leaving_users) then
            leaving_users.Free;
        end;
      end;
    finally
      CloseFile(t);
    end;
  end;
  {    }
  if is_found then
  begin
    Show;
    Application.Restore;
    Application.BringToFront;
  end;
  if (nick_found) and (EditOnNick.Text <> '') then
    for i := 0 to doc.forms.length - 1 do
    begin
      v := doc.forms.item(i);
      if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
        if v.name = ChatForm then
        begin
          for j := 0 to v.elements.length - 1 do
            if v.elements.item(j).name = ChatMessageItem then
              v.elements.item(j).value := EditOnNick.Text;
          doc.parentWindow.SendMessage;
          Break;
        end;
    end;
  FIsFirst := False;
end;

procedure TFormNarodBot.FormCreate(Sender: TObject);
begin
  try
    FNick := EditNick.Text;
    FPrevLog := nil;
    FIsFirst := True;
    FMsgTicks := GetTickCount - (ExpireMsgTicks + 1);
    Application.OnMinimize := ApplicationMinimize;
    EditMsg.Align := alClient;
    ComboBoxFilter.ItemIndex := 0;
    Randomize;
  finally
    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini')) do
      try
        EditLink.Text := ReadString('MAIN', 'LINK', EditLink.Text);
        CheckBoxAuto.Checked := (StrToIntDef(ReadString('MAIN',
          'AUTO', IntToStr(Ord(CheckBoxAuto.Checked))),
          Ord(CheckBoxAuto.Checked)) = Ord(True));
        CheckBoxAuth.Checked := (StrToIntDef(ReadString('MAIN',
          'AUTH', IntToStr(Ord(CheckBoxAuth.Checked))),
          Ord(CheckBoxAuth.Checked)) = Ord(True));
        EditLogin.Text := ReadString('MAIN', 'LOGIN', EditLogin.Text);
        EditPassword.Text := ReadString('MAIN', 'PASSWORD', EditPassword.Text);
        EditNick.Text := ReadString('MAIN', 'NICK', EditNick.Text);
        CheckBoxNickChange.Checked := (StrToIntDef(ReadString('MAIN',
          'NICKCHANGE', IntToStr(Ord(CheckBoxNickChange.Checked))),
          Ord(CheckBoxNickChange.Checked)) = Ord(True));
        EditChatLink.Text := ReadString('MAIN', 'CHATLINK', EditChatLink.Text);
        EditLogFile.Text := ReadString('MAIN', 'LOGFILE', EditLogFile.Text);
        CheckBoxLogIncludeDate.Checked := (StrToIntDef(ReadString('MAIN',
          'LOGINCLUDEDATE', IntToStr(Ord(CheckBoxLogIncludeDate.Checked))),
          Ord(CheckBoxLogIncludeDate.Checked)) = Ord(True));
        SpinEditFloodCount.Value := StrToIntDef(ReadString('MAIN',
          'FLOODCOUNT', IntToStr(SpinEditFloodCount.Value)),
          SpinEditFloodCount.Value);
        SpinEditFloodSize.Value := StrToIntDef(ReadString('MAIN',
          'FLOODSIZE', IntToStr(SpinEditFloodSize.Value)),
          SpinEditFloodSize.Value);
        CheckBoxFloodDebug.Checked := (StrToIntDef(ReadString('MAIN',
          'FLOODDEBUG', IntToStr(Ord(CheckBoxFloodDebug.Checked))),
          Ord(CheckBoxFloodDebug.Checked)) = Ord(True));
        CheckBoxOnNick.Checked := (StrToIntDef(ReadString('MAIN',
          'ONNICK', IntToStr(Ord(CheckBoxOnNick.Checked))),
          Ord(CheckBoxOnNick.Checked)) = Ord(True));
        EditOnNick.Text := ReadString('MAIN', 'MSGONNICK', EditOnNick.Text);
        CheckBoxPopupOnMessage.Checked := (StrToIntDef(ReadString('MAIN',
          'POPUPONMSG', IntToStr(Ord(CheckBoxPopupOnMessage.Checked))),
          Ord(CheckBoxPopupOnMessage.Checked)) = Ord(True));
        CheckBoxPopupOnNick.Checked := (StrToIntDef(ReadString('MAIN',
          'POPUPONNICK', IntToStr(Ord(CheckBoxPopupOnNick.Checked))),
          Ord(CheckBoxPopupOnNick.Checked)) = Ord(True));
      finally
        Free;
      end;
    FNick := EditNick.Text;
    if (CheckBoxAuto.Checked) and (EditLink.Text <> '') then
    begin
      FIsFirst := True;
      WebBrowser.Navigate(EditLink.Text);
    end;
    Application.ShowMainForm := (not CheckBoxAuto.Checked);
    if not Application.ShowMainForm then
      AddTaskBarIcon(Caption, Handle);
  end;
end;

procedure TFormNarodBot.FormDestroy(Sender: TObject);
begin
  try
    DelTaskBarIcon(Handle);
    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini')) do
      try
        WriteString('MAIN', 'LINK', EditLink.Text);
        WriteString('MAIN', 'AUTO', IntToStr(Ord(CheckBoxAuto.Checked)));
        WriteString('MAIN', 'AUTH', IntToStr(Ord(CheckBoxAuth.Checked)));
        WriteString('MAIN', 'LOGIN', EditLogin.Text);
        WriteString('MAIN', 'PASSWORD', EditPassword.Text);
        WriteString('MAIN', 'NICK', EditNick.Text);
        WriteString('MAIN', 'NICKCHANGE',
          IntToStr(Ord(CheckBoxNickChange.Checked)));
        WriteString('MAIN', 'CHATLINK', EditChatLink.Text);
        WriteString('MAIN', 'LOGFILE', EditLogFile.Text);
        WriteString('MAIN', 'LOGINCLUDEDATE',
          IntToStr(Ord(CheckBoxLogIncludeDate.Checked)));
        WriteString('MAIN', 'FLOODCOUNT',
          IntToStr(SpinEditFloodCount.Value));
        WriteString('MAIN', 'FLOODSIZE',
          IntToStr(SpinEditFloodSize.Value));
        WriteString('MAIN', 'FLOODDEBUG',
          IntToStr(Ord(CheckBoxFloodDebug.Checked)));
        WriteString('MAIN', 'ONNICK',
          IntToStr(Ord(CheckBoxOnNick.Checked)));
        WriteString('MAIN', 'MSGONNICK', EditOnNick.Text);
        WriteString('MAIN', 'POPUPONMSG',
          IntToStr(Ord(CheckBoxPopupOnMessage.Checked)));
        WriteString('MAIN', 'POPUPONNICK',
          IntToStr(Ord(CheckBoxPopupOnNick.Checked)));
      finally
        Free;
      end;
  finally
    if Assigned(FPrevLog) then
      FPrevLog.Free;
  end;
end;

procedure TFormNarodBot.ButtonInfoClick(Sender: TObject);
  var
    i, j, fi, fj: Integer;
    doc, v: OleVariant;
    s: string;
    f: file;
begin
  doc := WebBrowser.Document;
  if (VarIsEmpty(doc)) or (VarIsNull(doc)) then
    Exit;
  if (not VarIsEmpty(doc.body)) and (not VarIsNull(doc.body)) then
    if Trim(doc.body.innerHTML) <> '' then
    begin
      AssignFile(f, 'temp');
      try
        Rewrite(f, 1);
        s := doc.body.innerHTML;
        if Length(s) > 0 then
          BlockWrite(f, s[1], Length(s));
      finally
        CloseFile(f);
      end;
    end;
  for i := 0 to doc.forms.length - 1 do
  begin
    AllocConsole;
    WriteLn(WindowsToDos('FORM = ' + doc.forms.item(i).name));
    for j := 0 to doc.forms.item(i).elements.length - 1 do
    begin
      WriteLn(WindowsToDos('ITEM = ' +
        doc.forms.item(i).elements.item(j).name));
      try
        WriteLn(WindowsToDos('ITEM VALUE = ' +
          doc.forms.item(i).elements.item(j).value));
      except
      end;
    end;
    for j := 0 to doc.parentWindow.frames.length - 1 do
      WriteLn(WindowsToDos('FRAME = ' +
        doc.parentWindow.frames.item(j).name));
    for j := 0 to doc.parentWindow.frames.length - 1 do
    begin
      v := doc.parentWindow.frames.item(j).document;
      if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
        if (not VarIsEmpty(v.body)) and (not VarIsNull(v.body)) then
          if Trim(v.body.innerHTML) <> '' then
          begin
            ShowMessage(v.body.innerText);
            AssignFile(f, 'temp');
            try
              Rewrite(f, 1);
              s := v.body.innerHTML;
              if Length(s) > 0 then
                BlockWrite(f, s[1], Length(s));
            finally
              CloseFile(f);
            end;
            WriteLn(WindowsToDos('DETAILS: FRAME = ' +
              doc.parentWindow.frames.item(j).name));
            for fi := 0 to v.forms.length - 1 do
            begin
              WriteLn(WindowsToDos('FRAME FORM = ' + v.forms.item(fi).name));
              for fj := 0 to v.forms.item(fi).elements.length - 1 do
              begin
                WriteLn(WindowsToDos('FRAME ITEM = ' +
                  v.forms.item(fi).elements.item(fj).name));
                try
                  WriteLn(WindowsToDos('FRAME ITEM VALUE = ' +
                    v.forms.item(fi).elements.item(fj).value));
                except
                end;
              end;
            end;
          end;
    end;
  end;
end;

procedure TFormNarodBot.TimerRestartTimer(Sender: TObject);
begin
  if EditLink.Text <> '' then
  begin
    FIsFirst := True;
    WebBrowser.Navigate(EditLink.Text);
  end;
end;

procedure TFormNarodBot.TimerGoTimer(Sender: TObject);
begin
  TimerGo.Enabled := False;
  if EditChatLink.Text <> '' then
  begin
    FIsFirst := True;
    WebBrowser.Navigate(EditChatLink.Text);
  end;
end;

procedure TFormNarodBot.CheckBoxFloodDebugClick(Sender: TObject);
begin
  if not CheckBoxFloodDebug.Checked then
    FreeConsole;
end;

procedure TFormNarodBot.ButtonStopClick(Sender: TObject);
begin
  WebBrowser.Stop;
end;

procedure TFormNarodBot.FormShow(Sender: TObject);
begin
  DelTaskBarIcon(Handle);
end;

procedure TFormNarodBot.FormHide(Sender: TObject);
begin
  AddTaskBarIcon(Caption, Handle);
end;

procedure TFormNarodBot.EditMsgKeyPress(Sender: TObject; var Key: Char);
  var
    i, j: Integer;
    s: string;
    doc, v: OleVariant;
begin
  if (Key = #13) and (Trim(EditMsg.Text) <> '') then
  begin
    doc := WebBrowser.Document;
    if (not VarIsEmpty(doc)) and (not VarIsNull(doc)) then
      for i := 0 to doc.forms.length - 1 do
      begin
        v := doc.forms.item(i);
        if (not VarIsEmpty(v)) and (not VarIsNull(v)) then
          if v.name = ChatForm then
          begin
            for j := 0 to v.elements.length - 1 do
              if v.elements.item(j).name = ChatMessageItem then
              begin
                repeat
                  s := EditMsg.Text;
                  if Length(s) > MaxMsgLength then
                    s := Copy(s, 1, MaxMsgLength);
                  v.elements.item(j).value := s;
                  doc.parentWindow.SendMessage;
                  if Length(s) < Length(EditMsg.Text) then
                    EditMsg.Text := Copy(EditMsg.Text, Length(s) + 1,
                      Length(EditMsg.Text) - Length(s))
                  else
                  begin
                    EditMsg.Text := '';
                    Break;
                  end;
                until False;
                Key := #0;
                Break;
              end;
            Break;
          end;
      end;
  end;
end;

procedure TFormNarodBot.ButtonIgnoreClick(Sender: TObject);
  var
    s: string;
begin
  if (CheckListBoxNicks.ItemIndex < 0) or (CheckListBoxNicks.ItemIndex >=
  CheckListBoxNicks.Items.Count) then
    Exit;
  s := CheckListBoxNicks.Items[CheckListBoxNicks.ItemIndex];
  if Length(s) >= Length(IgnoreNickMark) then
    if Copy(s, 1, Length(IgnoreNickMark)) = IgnoreNickMark then
    begin
      CheckListBoxNicks.Items[CheckListBoxNicks.ItemIndex] := Copy(s,
        Length(IgnoreNickMark) + 1, Length(s) - Length(IgnoreNickMark));
      Exit;
    end;
  CheckListBoxNicks.Items[CheckListBoxNicks.ItemIndex] := IgnoreNickMark +
    CheckListBoxNicks.Items[CheckListBoxNicks.ItemIndex];
end;

procedure TFormNarodBot.CheckListBoxNicksDblClick(Sender: TObject);
begin
  if (CheckListBoxNicks.ItemIndex < 0) or (CheckListBoxNicks.ItemIndex >=
  CheckListBoxNicks.Items.Count) then
    Exit;
  EditMsg.Text := CheckListBoxNicks.Items[CheckListBoxNicks.ItemIndex] + ': ' +
    EditMsg.Text;
end;

procedure TFormNarodBot.ButtonFilterClick(Sender: TObject);
  var
    i, j: Integer;
    s, s_nick: string;
    log, res_log: TStringList;
begin
  res_log := nil;
  log := TStringList.Create;
  try
    log.Text := RichEditChat.Text;
    for i := 0 to log.Count - 1 do
    begin
      s := TrimLeft(log[i]);
      j := Pos(' ', s);
      if j > 0 then
        s := Copy(s, j + 1, Length(s) - j);
      s_nick := '';
      j := Pos(': ', s);
      if j > 0 then
      begin
        s_nick := Copy(s, 1, j - 1);
        s := Copy(s, j + 2, Length(s) - j - 1);
      end;
      for j := 0 to CheckListBoxNicks.Items.Count - 1 do
        if CheckListBoxNicks.Checked[j] then
          if CheckListBoxNicks.Items[j] = s_nick then
          begin
            if not Assigned(res_log) then
              res_log := TStringList.Create;
            res_log.Add(log[i]);  
          end;
    end;
    if Assigned(res_log) then
    begin
      s := ChangeFileExt(ParamStr(0), '.txt');
      res_log.SaveToFile(s);
      if ShellExecute(0, 'open', 'NOTEPAD.EXE',
      PChar(s), nil, SW_SHOWDEFAULT) <= 32 then
        MessageBeep($FFFFFFFF);
    end;
  finally
    try
      log.Free;
    finally
      if Assigned(res_log) then
        res_log.Free;
    end;
  end;
end;

end.
